WinMain proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD	      ;Prototype for Main Window
						
		;First = the window's instance
		;Second = instance handle of the previous instance of our program (only used in Win16)
		;Third = Commandline Instance
		;Fourth = window state at first appearance
            ;Fifth = ClassName
            ;Sixth = AppName




.CODE
;Keep this as a template for new windows.
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD,ClassName:DWORD,AppName:DWORD

  LOCAL wc:WNDCLASSEX		;create local variables on stack
  LOCAL msg:MSG
  LOCAL hwnd:HWND

  mov wc.cbSize,SIZEOF WNDCLASSEX
  mov wc.style,CS_HREDRAW or CS_VREDRAW
  mov wc.lpfnWndProc, OFFSET WndProc
  mov wc.cbClsExtra,NULL
  mov wc.cbWndExtra,NULL
  push hInstance
  pop wc.hInstance
  mov wc.hbrBackground,COLOR_WINDOW+1
  mov wc.lpszMenuName,NULL
  mov wc.lpszClassName,OFFSET ClassName
  invoke LoadIcon,NULL,IDI_APPLICATION
  mov wc.hIcon,eax
  mov wc.hIconSm,eax
  invoke LoadCursor,NULL,IDC_ARROW
  mov wc.hCursor,eax
  invoke RegisterClassEx, addr wc	;Register the window class.
  INVOKE CreateWindowEx,NULL,\
        ADDR ClassName,\
        ADDR AppName,\
        WS_OVERLAPPEDWINDOW,\
        CW_USEDEFAULT,\
	  CW_USEDEFAULT,\
        CW_USEDEFAULT,\
        CW_USEDEFAULT,\
        NULL,\
        NULL,\
        hInst,NULL
  mov hwnd,eax
  invoke ShowWindow, hwnd,CmdShow	;Show the window on desktop.
  invoke UpdateWindow, hwnd		;Refresh client area

  .WHILE TRUE				;Enter message loop
	invoke GetMessage, ADDR msg,NULL,0,0
	.BREAK .IF (!eax)
	invoke TranslateMessage, ADDR msg
	invoke DispatchMessage, ADDR msg
  .ENDW
  mov eax,msg.wParam			;Return exit code in eax
  ret
WinMain endp
